# coding: utf-8

"""
    UAM - Application API

    UAM manages client accounts and allows each client to define items, roles and auth methods. The core operations of UAM are as follows: Creating new accounts. For each account: Creating items. Adding new auth methods Adding new roles creating roles - auth methods association. Returning the key's metadata together with temporary access credentials in order to access the key fragments.  # noqa: E501

    OpenAPI spec version: 0.1.0
    Contact: refael@akeyless-security.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PublicSigningKeyReplyObj(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'expires': 'int',
        'pub_key_val': 'str'
    }

    attribute_map = {
        'expires': 'expires',
        'pub_key_val': 'pub_key_val'
    }

    def __init__(self, expires=None, pub_key_val=None):  # noqa: E501
        """PublicSigningKeyReplyObj - a model defined in Swagger"""  # noqa: E501

        self._expires = None
        self._pub_key_val = None
        self.discriminator = None

        if expires is not None:
            self.expires = expires
        if pub_key_val is not None:
            self.pub_key_val = pub_key_val

    @property
    def expires(self):
        """Gets the expires of this PublicSigningKeyReplyObj.  # noqa: E501

        The expiration date of the signing key (Unix time).  # noqa: E501

        :return: The expires of this PublicSigningKeyReplyObj.  # noqa: E501
        :rtype: int
        """
        return self._expires

    @expires.setter
    def expires(self, expires):
        """Sets the expires of this PublicSigningKeyReplyObj.

        The expiration date of the signing key (Unix time).  # noqa: E501

        :param expires: The expires of this PublicSigningKeyReplyObj.  # noqa: E501
        :type: int
        """

        self._expires = expires

    @property
    def pub_key_val(self):
        """Gets the pub_key_val of this PublicSigningKeyReplyObj.  # noqa: E501

        The public key value.  # noqa: E501

        :return: The pub_key_val of this PublicSigningKeyReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._pub_key_val

    @pub_key_val.setter
    def pub_key_val(self, pub_key_val):
        """Sets the pub_key_val of this PublicSigningKeyReplyObj.

        The public key value.  # noqa: E501

        :param pub_key_val: The pub_key_val of this PublicSigningKeyReplyObj.  # noqa: E501
        :type: str
        """

        self._pub_key_val = pub_key_val

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PublicSigningKeyReplyObj, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublicSigningKeyReplyObj):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
