# coding: utf-8

"""
    UAM - Application API

    UAM manages client accounts and allows each client to define items, roles and auth methods. The core operations of UAM are as follows: Creating new accounts. For each account: Creating items. Adding new auth methods Adding new roles creating roles - auth methods association. Returning the key's metadata together with temporary access credentials in order to access the key fragments.  # noqa: E501

    OpenAPI spec version: 0.1.0
    Contact: refael@akeyless-security.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class UploadRSAFragmentReplyObj(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'test_signature': 'str'
    }

    attribute_map = {
        'test_signature': 'test_signature'
    }

    def __init__(self, test_signature=None):  # noqa: E501
        """UploadRSAFragmentReplyObj - a model defined in Swagger"""  # noqa: E501

        self._test_signature = None
        self.discriminator = None

        if test_signature is not None:
            self.test_signature = test_signature

    @property
    def test_signature(self):
        """Gets the test_signature of this UploadRSAFragmentReplyObj.  # noqa: E501

        Result of the signature operation on a test message using the uploaded fragment.  # noqa: E501

        :return: The test_signature of this UploadRSAFragmentReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._test_signature

    @test_signature.setter
    def test_signature(self, test_signature):
        """Sets the test_signature of this UploadRSAFragmentReplyObj.

        Result of the signature operation on a test message using the uploaded fragment.  # noqa: E501

        :param test_signature: The test_signature of this UploadRSAFragmentReplyObj.  # noqa: E501
        :type: str
        """

        self._test_signature = test_signature

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UploadRSAFragmentReplyObj, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UploadRSAFragmentReplyObj):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
